import ZSI
from pyGridWare.patterns import Singleton
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceContext import ResourceContext
from PythonCLServiceTool.cat.underware.generated.properties.cat.PythonCLServiceTool_cat.PythonCLServiceTool_catPort import PythonCLServiceTool_catPortType


class Key(int):
    typecode = ZSI.TC.Iint(pname=('urn:PythonCLServiceTool_cat','PythonCLServiceTool_catKey'))


class ManagerHome(PersistentResourceHome, Singleton):
    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, Key.typecode)
        return self.get(key)


class PythonCLServiceTool_catPortTypeContext(ResourceContext):
    def __init__(self, properties_class=PythonCLServiceTool_catPortType):
        ResourceContext.__init__(self, properties_class)

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, Key(resourceID))
PythonCLServiceTool_catPortTypeContext.home = ManagerHome.getInstance()

